/*
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 */

 #include "waltoptablet.h"


static struct waltoptablet_features waltoptablet_features_table[] = {
	{ "Tablet", 	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "My Note T01S",	TOP_MYNOTE, 8 }, 
	
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "My Note R01",	TOP_MYNOTE2, 8 },
	
	{ "Slim Tablet",	TOP_NONE, 8 },
	{ "Whiteboard",	TOP_MYNOTE2, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	{ "Media Tablet",	TOP_NONE, 8 },
	{ "Tablet",	TOP_NONE, 8 },
	
	{ "Tablet", 	TOP_NONE, 8},	
	{}
};


/***************************************************************************** 
 * Device Tables
 ****************************************************************************/

 static struct usb_device_id waltoptablet_ids[] = {
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0022) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0024) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0025) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0026) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0027) },
	
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0028) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0030) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0031) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0032) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0033) },
	
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0034) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0035) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0036) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0037) },	
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0038) },
	
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0039) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0051) },	
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0052) },	
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0053) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0054) },
	
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0055) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0056) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0058) },
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0500) },	
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0501) },
	
	{ USB_DEVICE(USB_VENDOR_ID_WALTOP, 0x0502) },	
	{ }
};

MODULE_DEVICE_TABLE(usb, waltoptablet_ids);

/***************************************************************************** 
 * Driver Function Definitions
 ****************************************************************************/

static int 
waltoptablet_id1(struct waltoptablet* waltop)
{
	unsigned char *data = waltop->data;
	
	printk(KERN_DEBUG "%s - (x,y)=(%d,%d)\n", __FUNCTION__, data[2], data[3]);
	
	input_report_rel(waltop->input_dev, REL_X, data[2]);
	input_report_rel(waltop->input_dev, REL_Y, data[3]);

	input_report_key(waltop->input_dev, BTN_LEFT, (data[1]&0x1) );
	input_report_key(waltop->input_dev, BTN_MIDDLE, ((data[1]&0x2)>>1) );
	input_report_key(waltop->input_dev, BTN_RIGHT, ((data[1]&0x4)>>2) );

	input_report_rel(waltop->input_dev, REL_MISC, 1);
	return 1;
}


static int 
waltoptablet_id2(struct waltoptablet* waltop)
{
	unsigned char *data = waltop->data;
	int x, y, z, in_range, dv, tip, btn_up, btn_low;


	x = data[1] + data[2] * 256;
	y = data[3] + data[4] * 256;
	z = data[6] + data[7] * 256;
	in_range = data[5]&0x1;
	dv = (data[5]&0x2)>>1;
	tip = (data[5]&0x4)>>2;
	btn_low = (data[5]&0x8)>>3;
	btn_up = (data[5]&0x10)>>4;	

	printk(KERN_DEBUG "%s - (%d,%d,%d),in=%d,dv=%d,tip=%d,btn_low=%d,btn_up=%d\n",
			__FUNCTION__, x, y, z, in_range, dv, tip, btn_low, btn_up);

	input_report_key(waltop->input_dev, BTN_TOOL_PEN, in_range>0 ? 1:0);
	input_report_key(waltop->input_dev, BTN_TOUCH, in_range>0 ? tip:0);
	input_report_abs(waltop->input_dev, ABS_MISC, in_range>0 ? BTN_TOOL_PEN:0);
	
	if(in_range>0){
		input_report_abs(waltop->input_dev, ABS_X, x);
		input_report_abs(waltop->input_dev, ABS_Y, y);
		input_report_abs(waltop->input_dev, ABS_PRESSURE, tip>0 ? z:0);		
			
		input_report_key(waltop->input_dev, BTN_STYLUS, btn_low);
		input_report_key(waltop->input_dev, BTN_STYLUS2, btn_up);	
	}
	return 1;

}


static int 
waltoptablet_id2_mynote2(struct waltoptablet* waltop)
{
	unsigned char *data = waltop->data;
	int x, y, z, in_range, dv, tip, colorindex;


	x = data[1] + data[2] * 256;
	y = data[3] + data[4] * 256;
	z = data[7];
	in_range = data[6]&0x1;
	dv = (data[6]&0x2)>>1;
	tip = (data[6]&0x7)>>2;
	colorindex = z>>12;
	z &= 0x0fff; 

	printk(KERN_DEBUG "%s - (%d,%d,%d),in=%d,dv=%d,tip=%d,color=%d\n",
			__FUNCTION__, x, y, z, in_range, dv, tip, colorindex);
	
	input_report_key(waltop->input_dev, BTN_TOOL_PEN, in_range>0 ? 1:0);
	input_report_key(waltop->input_dev, BTN_TOUCH, in_range>0 ? tip:0);
	input_report_abs(waltop->input_dev, ABS_MISC, in_range>0 ? BTN_TOOL_PEN:0);
	
	if(in_range>0){
		input_report_abs(waltop->input_dev, ABS_X, x);
		input_report_abs(waltop->input_dev, ABS_Y, y);
		input_report_abs(waltop->input_dev, ABS_PRESSURE, tip>0 ? z:0);
	}
	return 1;

}


static int 
waltoptablet_id2_mynote(struct waltoptablet* waltop)
{
	unsigned char *data = waltop->data;
	int x, y, z, in_range, dv, tip;


	x = data[1] + data[2] * 256;
	y = data[3] + data[4] * 256;
	z = data[6] + data[7] * 256;
	in_range = data[5]&0x1;
	dv = (data[5]>>1)&0x2;
	tip = (data[5]>>2)&0x1;

	printk(KERN_DEBUG "%s - (%d,%d,%d),in=%d,dv=%d,tip=%d\n",
			__FUNCTION__, x, y, z, in_range, dv, tip);
				
	input_report_key(waltop->input_dev, BTN_TOOL_PEN, in_range>0 ? 1:0);
	input_report_key(waltop->input_dev, BTN_TOUCH, in_range>0 ? tip:0);	
	input_report_abs(waltop->input_dev, ABS_MISC, in_range>0 ? BTN_TOOL_PEN:0);
	
	if(in_range>0){
		input_report_abs(waltop->input_dev, ABS_X, x);
		input_report_abs(waltop->input_dev, ABS_Y, y);
		input_report_abs(waltop->input_dev, ABS_PRESSURE, tip>0 ? z:0);
	}
	return 1;

}


static int 
waltoptablet_irq(struct waltoptablet *waltop)
{	
	switch(waltop->data[0])
	{
	case 1:/* relative coordinate */
		{
			return waltoptablet_id1(waltop);
		}
		break;
		
	case 2: /* absolute coordinate */
		{
			if(waltop->features->top == TOP_MYNOTE)
				return waltoptablet_id2_mynote(waltop);
				
			else if(waltop->features->top == TOP_MYNOTE2)
				return waltoptablet_id2_mynote2(waltop);
				
			else
				return waltoptablet_id2(waltop);
		} 
		break;

	default:
		printk(KERN_DEBUG "%s - id=%d\n", __FUNCTION__, waltop->data[0]);
		return 0;
	}
}

static void 
waltoptablet_sys_irq(struct urb *urb)
{
	struct waltoptablet *waltop = urb->context; 
	int retval;


	switch(urb->status)
	{
	case 0: 
		/* success */
		break;

	case -ECONNRESET:
	case -ENOENT:
	case -ESHUTDOWN:
		/* This urb is terminated, clean up */
		printk(KERN_DEBUG "%s - urb sutting down with status: %d\n", __FUNCTION__, urb->status);
		return;

	default:
		printk(KERN_DEBUG "%s - nonzero urb status received: %d\n", __FUNCTION__, urb->status);
		goto exit;
	}
	
	if(waltoptablet_irq(waltop))
		input_sync(waltop->input_dev);

exit:
	retval = usb_submit_urb(urb, GFP_ATOMIC);
	if(retval)
		printk(KERN_ERR "%s:%d - error:%d\n", __FILE__, __LINE__, retval);

}


struct waltoptablet_features* 
get_waltoptablet_features(const struct usb_device_id *id)
{
	int index = id - waltoptablet_ids;
	struct waltoptablet_features *f = &waltoptablet_features_table[index];
	return f;
}


static int 
waltoptablet_open(struct input_dev *dev)
{
	//struct waltoptablet *waltop  = dev->private; //for kernel 2.6.21
	struct waltoptablet *waltop  = input_get_drvdata( dev );
	waltop->irq->dev = waltop->usb_dev;

	if(usb_submit_urb(waltop->irq, GFP_KERNEL)){
		printk(KERN_ERR "%s - error\n", __FUNCTION__);
		return -EIO;
	}
	printk(KERN_INFO "%s - success!\n", __FUNCTION__);
	return 0;	
}


static void 
waltoptablet_close(struct input_dev *dev)
{
	//struct waltoptablet *waltop  = dev->private; //for kernel 2.6.21
	struct waltoptablet *waltop  = input_get_drvdata( dev );

	usb_kill_urb(waltop->irq);
}


static int 
waltoptablet_probe(struct usb_interface *intf, const struct usb_device_id *id)
{
	struct usb_device 		*usb_dev = interface_to_usbdev(intf);
	struct usb_endpoint_descriptor *endpoint;
	struct waltoptablet 	*waltop;
	struct input_dev 		*input_dev;
	int retval;
	int max_x, max_y, max_pressure;


	waltop = kzalloc(sizeof(struct waltoptablet), GFP_KERNEL);
	input_dev = input_allocate_device();
	if(!waltop || !input_dev){
		printk(KERN_ERR "%s:%d\n", __FILE__, __LINE__);
		goto fail1;
	}

	waltop->features = get_waltoptablet_features(id);

	waltop->data = usb_buffer_alloc(usb_dev, waltop->features->pktlen, GFP_KERNEL, &waltop->data_dma);
	if(!waltop->data){
		printk(KERN_ERR "%s:%d\n", __FILE__, __LINE__);
		goto fail1;
	}

	waltop->irq = usb_alloc_urb(0, GFP_KERNEL);
	if(!waltop->irq){
		printk(KERN_ERR "%s:%d\n", __FILE__, __LINE__);
		goto fail2;
	}
	
	waltop->interface_number = intf->altsetting[0].desc.bInterfaceNumber;

	waltop->usb_dev 		= usb_dev;
	waltop->input_dev 	= input_dev;

	usb_make_path(usb_dev, waltop->phys, sizeof(waltop->phys));
	strlcat(waltop->phys, "/input0", sizeof(waltop->phys));

	input_dev->name 		= waltop->features->name;
	input_dev->phys 		= waltop->phys;
	
	usb_to_input_id(usb_dev, &input_dev->id);
	
	//input_dev->private 	= waltop;  //for Kernel 2.6.21
	input_set_drvdata(input_dev , waltop);
	input_dev->dev.parent = &intf->dev;
	input_dev->open 		= waltoptablet_open;
	input_dev->close		= waltoptablet_close;

	if(waltoptablet_setOperationMode_tablet(waltop)==false){
		printk(KERN_ERR "%s:%d\n", __FILE__, __LINE__);
		goto fail2;
	}
	
	max_x = waltoptablet_getMaxX(waltop);	
	max_y = waltoptablet_getMaxY(waltop);
	max_pressure = waltoptablet_getMaxPressure(waltop);
	printk(KERN_DEBUG "%s - (x,y,z)=(%d,%d,%d)\n", __FUNCTION__, max_x, max_y, max_pressure);


	input_dev->evbit[0] |= BIT_MASK(EV_KEY) | BIT_MASK(EV_ABS) | BIT_MASK(EV_REL)/* | BIT(EV_MSC)*/;
	
	input_dev->relbit[0] |=  BIT_MASK(REL_X) | BIT_MASK(REL_Y) | BIT_MASK(REL_WHEEL) | 
BIT_MASK(REL_MISC);

	input_dev->keybit[BIT_WORD(BTN_LEFT)] |= BIT_MASK(BTN_LEFT) | BIT_MASK(BTN_RIGHT) | 
BIT_MASK(BTN_MIDDLE);
	
	input_dev->keybit[BIT_WORD(BTN_DIGI)] |= BIT_MASK(BTN_TOOL_PEN) | BIT_MASK(BTN_TOUCH) | 
BIT_MASK(BTN_STYLUS) | BIT_MASK(BTN_STYLUS2);	
			
	input_set_abs_params(input_dev, ABS_X, 0, max_x, 4, 0);
	input_set_abs_params(input_dev, ABS_Y, 0, max_y, 4, 0);
	input_set_abs_params(input_dev, ABS_PRESSURE, 0, max_pressure, 0, 0);	

	input_dev->absbit[BIT_WORD(ABS_MISC)] |= BIT_MASK(ABS_MISC);


	endpoint = &intf->cur_altsetting->endpoint[0].desc;
	
	usb_fill_int_urb(waltop->irq, 
			usb_dev,
			usb_rcvintpipe(usb_dev, endpoint->bEndpointAddress),
			waltop->data, 
			waltop->features->pktlen,
			waltoptablet_sys_irq, 
			waltop, 
			endpoint->bInterval);

	waltop->irq->transfer_dma	= waltop->data_dma;
	waltop->irq->transfer_flags 	|= URB_NO_TRANSFER_DMA_MAP;
	
	retval = input_register_device(waltop->input_dev);
	if(retval){
		printk(KERN_ERR "%s:%d - error:%d\n", __FILE__, __LINE__, retval);
		goto fail2;
	}
	
	usb_set_intfdata(intf, waltop);
	return 0;
	
fail2:
	usb_buffer_free(usb_dev, waltop->features->pktlen, 
		waltop->data, waltop->data_dma);

fail1:
	input_free_device(input_dev);
	kfree(waltop);
	return -ENOMEM;	
}


static void 
waltoptablet_disconnect(struct usb_interface *intf)
{
	struct waltoptablet *waltop = usb_get_intfdata(intf);


	usb_set_intfdata(intf, NULL);
	
	if(waltop){
		usb_kill_urb(waltop->irq);
		input_unregister_device(waltop->input_dev);
		usb_free_urb(waltop->irq);
		usb_buffer_free(interface_to_usbdev(intf), 
				waltop->features->pktlen, 
				waltop->data, 
				waltop->data_dma);
		kfree(waltop);
	}

}


static struct usb_driver waltoptablet_driver = {
	.name 	= "waltoptablet",
	.probe 	= waltoptablet_probe,
	.disconnect = waltoptablet_disconnect,
	.id_table 	= waltoptablet_ids,
};


/***************************************************************************** 
 * Module Function Definitions
 ****************************************************************************/
static int __init waltoptablet_init(void)
{
	int result;

	result = usb_register(&waltoptablet_driver);
	if(result==0){
		info(DRIVER_VERSION ":" DRIVER_DESC);
	}
	printk(KERN_DEBUG "%s\n", __FUNCTION__);
	return result;
}


static void __exit waltoptablet_exit(void)
{
	usb_deregister(&waltoptablet_driver);
	printk(KERN_DEBUG "%s\n", __FUNCTION__);
}

module_init(waltoptablet_init);
module_exit(waltoptablet_exit);

