/*
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 */

#ifndef _WALTOPTABLET_H_
#define _WALTOPTABLET_H_

#include <linux/kernel.h>
#include <linux/slab.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/usb/input.h>
#include <asm/unaligned.h>

/*
 *
 */
 
#define DRIVER_VERSION 	"v1.00"
#define DRIVER_AUTHOR	""
#define DRIVER_DESC		"USB WALTOP Tablet Driver"
#define DRIVER_LICENSE	"GPL"


MODULE_AUTHOR(DRIVER_AUTHOR);
MODULE_DESCRIPTION(DRIVER_DESC);
MODULE_LICENSE(DRIVER_LICENSE);
MODULE_VERSION("1.00");


#define USB_VENDOR_ID_WALTOP	0x172f


/*
 *
 */

enum {
	TOP_NONE,
	TOP_MYNOTE,
	TOP_MYNOTE2,
};

struct waltoptablet_features{
	char 		*name;
	int 		top;	
	int 		pktlen;
};
 
struct waltoptablet{
	dma_addr_t 		data_dma;
	struct input_dev 	*input_dev;
	struct usb_device 	*usb_dev;
	struct urb 		*irq;
	struct waltoptablet_features *features;
	char 			phys[32];
	unsigned int 		interface_number; // interface number for IO
	unsigned char		*data;
};


/***************************************************************************** 
 * Command prototypes
 */
extern int waltoptablet_getMaxX(struct waltoptablet* waltop);
extern int waltoptablet_getMaxY(struct waltoptablet* waltop);
extern int waltoptablet_getMaxPressure(struct waltoptablet* waltop);
extern bool waltoptablet_setOperationMode_default(struct waltoptablet* waltop);
extern bool waltoptablet_setOperationMode_tablet(struct waltoptablet* waltop);
extern bool waltoptablet_setOperationMode_ink(struct waltoptablet* waltop);
#endif
